//
//  iStunnelViewController.m
//  iStunnel
//
//  Created by Кондакова Татьяна Андреевна on 03.12.10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "iStunnelViewController.h"
#import <sys/types.h>
#import <dirent.h>
#import <sys/stat.h>
#import <vector>
#import <list>
#import <CPROCSP/CPROCSP.h>
#import <CPROCSP/ManageCertsAndConts.h>
#import <CPROCSP/ModalSelect.h>
#import <CFNetwork/CFProxySupport.h>
#import <CoreFoundation/CFString.h>
#import "BrowserViewController.h"

extern bool USE_CACHE_DIR;
bool USE_CACHE_DIR = false;

extern "C" {
extern int stunnel_main(int argc, char** argv);
}
@implementation iStunnelViewController

#pragma mark -
#pragma mark Memory management


- (void) viewDidLoad{
	[super viewDidLoad];
	state = false;
	[browser setTitleColor:[UIColor lightGrayColor] forState:UIControlStateDisabled];
	browser.enabled = NO;
	
	NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
	NSString *val = nil;
	
	if (standardUserDefaults) 
		val = [standardUserDefaults objectForKey:@"ServerURL"];
	if(val){
		if([val length]){
			serverURL = [val UTF8String];
		}
	}
	
}

#pragma mark -
#pragma mark Views lifecycle

static BOOL StrTPToHex(const char * src,DWORD sLen, BYTE * dst, DWORD *pdLen)
{
    int i,j,k;
    for (i=sLen,j=*pdLen;i>0 && j>0;i-=2,j--)
    {
		BYTE b = 0;
		for (k=0;k<2;k++)
		{
            BYTE c = tolower(*src++);
			b<<=4;
			if (c >= 'a' && c <= 'f')
				b|=c-'a'+10;
			else if (isdigit(c))
				b|=c - '0';
			else
				return FALSE;
		}	
		*dst++ = b;
    }
	*pdLen-=j;
    return TRUE;
}

int WriteToFile(const char* FileName, void* Data,size_t DataSize)
{
	FILE* file = fopen(FileName,_TEXT("wb"));
	if(!file)
	{
		free(Data);
		return NTE_FAIL;
	}
	if( DataSize != fwrite(Data,sizeof(char),DataSize,file) )
	{
		free(Data);
		fclose(file);
		return NTE_FAIL;
	}
	fclose(file);
	//    ::free(Data);
	return 0;	
}

void * stunnel_routine(void *data){
	char *argv[]={(char *)"stunnel", (char*) data};
	stunnel_main(2, argv);
	return NULL;
}


-(void)connect{
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentsDirectory = [paths objectAtIndex:0];
	NSString *auth = @"";
	
//если выбран клиентский сертификат, настраиваем двухстороннюю аутентификацию
	if ( certThumbprint.size() && (certThumbprint != "No certificate")) {
		BYTE bSHA1Digest[20];
		CRYPT_HASH_BLOB bHash; 
		HCERTSTORE hStoreMy = 0;
		PCCERT_CONTEXT pCertCtx = 0;
		bHash.cbData = 20;
		bHash.pbData = bSHA1Digest;
		if (!StrTPToHex(certThumbprint.c_str(), 40, bHash.pbData, &bHash.cbData))
		{
			return;
		}
		
		hStoreMy = CertOpenSystemStore(0,"MY");
		pCertCtx =  CertFindCertificateInStore(hStoreMy,
											   X509_ASN_ENCODING | PKCS_7_ASN_ENCODING,
											   0,CERT_FIND_HASH,&bHash,0);
		if(!pCertCtx){
			return;
		}
		
		BYTE *EncCert;
	    DWORD EncCertSize;
		
	    EncCertSize=pCertCtx->cbCertEncoded;
	    if(!(EncCert=(BYTE*)malloc(EncCertSize)))
			return;
	    memcpy(EncCert,pCertCtx->pbCertEncoded,EncCertSize);
		//файл сертификата храним в каталоге приложения
		//если это не удобно -- положите в другое место
		if(WriteToFile( [[NSString stringWithFormat:@"%@/client.cer", documentsDirectory] UTF8String],
							EncCert,EncCertSize))
		    return;
		auth = [NSString stringWithFormat: @"cert=%@/client.cer", documentsDirectory];
	}
//дальше считываем системные настройки прокси и используем их для конфигурирования stunnel
//если вход в ssl-туннель организовывается не через системный прокси, это надо заифнолить
//и определять вход в туннель иначе; как -- тема отдельного разговора.
//зависит от того как у вас организована работа с сетью
//лучше всего если мы обсудим это с разработчиками с вашей стороны
//#if 0	
	CFDictionaryRef proxyDicRef = CFNetworkCopySystemProxySettings();
	
	/*CFNumberRef cfAutoConfigEnable = (CFNumberRef)CFDictionaryGetValue(
																  proxyDicRef,
																  kCFNetworkProxiesProxyAutoConfigEnable);
	if(!cfAutoConfigEnable){
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Proxy settings error" message:@"Can't get proxy settings." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles: nil];
        [alertView show];
        [alertView release];
		return;
	}
	int autoConfigEnable;
	if(!CFNumberGetValue(cfAutoConfigEnable, kCFNumberIntType, &autoConfigEnable)){
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Proxy settings error" message:@"Can't get proxy settings." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles: nil];
        [alertView show];
        [alertView release];
		return;
	}
	if(autoConfigEnable){
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Proxy settings error" message:@"Disable auto configuration." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles: nil];
        [alertView show];
        [alertView release];
		return;
	}*/
	
	CFNumberRef cfHttpProxyOn = (CFNumberRef)CFDictionaryGetValue(
												proxyDicRef,
												kCFNetworkProxiesHTTPEnable);
	if(!cfHttpProxyOn){
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Proxy settings error" message:@"Proxy disabled. Configure localhost as proxy server." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles: nil];
        [alertView show];
		return;
	}
	int httpEnabled;
	if(!CFNumberGetValue(cfHttpProxyOn, kCFNumberIntType, &httpEnabled)){
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Proxy settings error" message:@"Proxy disabled. Configure localhost as proxy server." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles: nil];
        [alertView show];
		return;
	}
	if(!httpEnabled){
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Proxy settings error" message:@"Proxy disabled. Configure localhost as proxy server." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles: nil];
        [alertView show];
		return;
	}
	
	CFStringRef cfHttpProxy = (CFStringRef) CFDictionaryGetValue(
												proxyDicRef,
												kCFNetworkProxiesHTTPProxy);
	if(!cfHttpProxy){
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Proxy settings error" message:@"Can't get server name." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles: nil];
        [alertView show];
		return;
	}
	const char * httpProxy = CFStringGetCStringPtr(cfHttpProxy,
								kCFStringEncodingMacRoman);
	if(strcmp(httpProxy, "127.0.0.1") && strcmp(httpProxy, "localhost")){
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Proxy settings error" message:@"Wrong server name. Use localhost or 127.0.0.1 ." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles: nil];
        [alertView show];
		return;
	}
	
	CFNumberRef cfHttpPort = (CFNumberRef)CFDictionaryGetValue(
												proxyDicRef,
												kCFNetworkProxiesHTTPPort);
	if(!cfHttpPort){
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Proxy settings error" message:@"Can't get port number." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles: nil];
        [alertView show];
		return;
	}
	if(!CFNumberGetValue(cfHttpPort, kCFNumberIntType, &proxyPort)){
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Proxy settings error" message:@"Can't get port number." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles: nil];
        [alertView show];
		return;
	}
//#endif	
	if(!serverURL.size()){
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Wrong parameters" message:@"Specify server URL." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles: nil];
        [alertView show];
		return;
	}
		
//делаем файл конфигурации, о значении опций в файле можно почитать тут: http://cryptopro.ru/products/other/stunnel#downloads
//или в man stunnel на юниксовой машине, на которой установлен пакет stunnel
    NSString *fileName = [NSString stringWithFormat:@"%@/stunnel.conf", documentsDirectory];
    NSString *content = [NSString stringWithFormat: @"pid = %@/cprocsp/tmp/stunnel.pid\n\
output = %@/cprocsp/tmp/stunnel.log\nsocket = a:SO_REUSEADDR=1\n\
foreground = yes\ndebug = 7\nsocket = l:TCP_NODELAY=1\nsocket = r:TCP_NODELAY=1\n\
[test]\nclient = yes\naccept = %s:%d\nconnect = %s:%s\n%@",
						 documentsDirectory, documentsDirectory,httpProxy,proxyPort,
						 serverURL.c_str(),server_port_number,auth];

    [content writeToFile:fileName 
				atomically:YES
				encoding:NSStringEncodingConversionAllowLossy 
                error:nil];
	NSLog(@"%@", content);
	const char *fname_temp = [fileName UTF8String];
	char *fname = (char *)malloc(strlen(fname_temp + 1));
	strcpy(fname, fname_temp);

//	char *argv[]={"stunnel", fname};
//	stunnel_main(2, argv);
	
	pthread_attr_t attr;
	pthread_t threadID;
	int ret = pthread_attr_init(&attr);
	ret = pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
//запускаем в отдельной нитке, передаём в качестве параметра имя файла с конфигурацией
	int error = pthread_create(&threadID, &attr, &stunnel_routine, (void *)fname);
	ret = pthread_attr_destroy(&attr);
	if (error != 0){
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"CryptoPro iStunnel" message:@"Error while starting stunnel" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles: nil];
        [alertView show];
		return;
	}
 
	browser.enabled = YES;
	state = true;
	NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
	
	if (standardUserDefaults) {
		[standardUserDefaults setObject:
								 [NSString stringWithUTF8String: serverURL.c_str()]
								 forKey:@"ServerURL"];
		[standardUserDefaults synchronize];
	}
	
}

-(IBAction)launchBrowser:(id)sender {
	NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
	
	BrowserViewController * cont = [[BrowserViewController alloc] init];
        cont.urlAddress = [NSString stringWithFormat: @"http://localhost:%d/", proxyPort];
	[cont setModalPresentationStyle:UIModalPresentationFullScreen];
	[self presentViewController:cont animated:YES completion:nil];
}

-(IBAction)doConfigure:(id)sender {
//печатает лог на консоль:)
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentsDirectory = [paths objectAtIndex:0];
	NSString *fileName = [NSString stringWithFormat:@"%@/cprocsp/tmp/stunnel.log", documentsDirectory];
	const char *fname = [fileName UTF8String];
	FILE * pFile = fopen(fname, "r");
	if(!pFile){
		NSLog(@"error while opening file");
		return;
	}
	fseek(pFile,0,SEEK_END);
	long size = ftell(pFile);
	rewind(pFile);
	
	char *_log = (char*)malloc(size);

	fread(_log,1,size,pFile);
	puts(_log);
	free(_log);
	fclose(pFile);
}

-(IBAction)startPane:(id)sender{
	[self launchPane];
}

//запускает криптопрошную панель с возможностью выпуска сертификатов и т.п.
-(void) launchPane
{
	CPROPane = [[PaneViewController alloc] init];
	UINavigationController * cont = [[UINavigationController alloc] initWithRootViewController:CPROPane];
	[cont setModalPresentationStyle:UIModalPresentationFullScreen];
	[self presentViewController:cont animated:YES completion:nil];
}

-(void)alertView: (UIAlertView *) alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
    if(buttonIndex == 1) //OK
    {
        serverURL = [[[alertView textFieldAtIndex:0] text] UTF8String];
        [tableView reloadData];
    }
}

-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
	return 2;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	switch (section) {
		case 0:
			return 2;
		default:
			return 1;
	}
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	
	static NSString *CellIdentifier = @"Cell";
	
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (cell == nil) {
		cell = [[UITableViewCell alloc] initWithStyle: UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
	}
	
	if(indexPath.section == 0){
		if(indexPath.row == 0){
			cell.textLabel.text = @"Server URL: ";
			if(serverURL.size() > 0)
				cell.textLabel.text = [@"Server URL: " stringByAppendingString:
						 [NSString stringWithUTF8String: serverURL.c_str()]];
			cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
		}
		if(indexPath.row == 1){
			cell.textLabel.text = @"Certificate: ";
			if(certThumbprint.size() > 0)
				cell.textLabel.text = [@"Certificate: " stringByAppendingString:
							 [NSString stringWithUTF8String: certThumbprint.c_str()]];
			cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
		}
	}
	
	if(indexPath.section == 1){
		if(indexPath.row == 0){
			cell.textLabel.text = @"Connect";
			cell.textLabel.textAlignment = NSTextAlignmentCenter;
			cell.accessoryType = UITableViewCellAccessoryNone;
		}
	}
	if(!state)
		cell.textLabel.textColor = [UIColor blackColor];
	else
		cell.textLabel.textColor = [UIColor lightGrayColor];
	
	return cell;	
}

- (void)tableView:(UITableView *)tView accessoryButtonTappedForRowWithIndexPath:(NSIndexPath *)indexPath
{
	[self tableView:tView didSelectRowAtIndexPath:indexPath];
}

-(void)selectCertificate
{
    //перечисление сертификатов и диалог для выбора
    std::vector<std::string> RDN;
    std::vector<std::string> notBefore;
    std::vector<std::string> notAfter;
    std::vector<std::string> thumbprint;
    EnumCerts(RDN, notBefore, notAfter, thumbprint );
    
    certInfoArray = [NSMutableArray arrayWithCapacity:0];
    thumbprintArray = [NSMutableArray arrayWithCapacity:0];
    
    for(int i = 0; i < thumbprint.size(); ++i){
        [thumbprintArray addObject:[NSString stringWithCString:thumbprint[i].c_str() encoding: NSWindowsCP1251StringEncoding]];
        [certInfoArray addObject:[NSString
                                  stringWithCString:(RDN[i] + "\t \tValid " + notBefore[i] + " - " + notAfter[i]).c_str()
                                  encoding: NSWindowsCP1251StringEncoding]];
    }
    [thumbprintArray addObject:@"No certificate"];
    [certInfoArray addObject:@"None"];
    
    int ret = [ModalSelect show_select_dialog:@"choose certificate" button_list:certInfoArray];
    if(ret){
        certThumbprint = [[thumbprintArray objectAtIndex:ret - 1] cString];
    }
    [tableView reloadData];
}

-(void)tableView:(UITableView *)tView  didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	if(indexPath.section == 0){
		if(indexPath.row == 0){
            UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"CryptoPro iStunnel" message:@"Input server URL:" delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"OK", nil];
            [alertView setAlertViewStyle: UIAlertViewStylePlainTextInput];
			[alertView show];
		}
		if(indexPath.row == 1){
		    [self performSelectorOnMainThread:@selector(selectCertificate) withObject:nil waitUntilDone:NO];
        }
	}
	
	if(indexPath.section == 1){
		if(indexPath.row == 0){
			if(!state){
				[self connect];
				[tableView reloadData];
			}
		}
	}
}


@end

